<?php
namespace FiloBlu\Refilo\Console\Command;

use FiloBlu\Refilo\Model\Exporter\Categories;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class ImportCategories
 */
class RegenerateSeoProduct extends Command
{
    const NAME = 'name';
    /**
     * @var Categories
     */
    private $categories;

    /**
     * ImportBlocks constructor.
     * @param Categories $categoriesBlock
     * @param string $name
     */
    public function __construct(
        Categories $categoriesBlock,
        string $name = null
    ) {
        $this->categories = $categoriesBlock;
        parent::__construct($name);
    }

    /**
     * @inheritDoc
     */
    protected function configure()
    {
        $options = [
            new InputOption(
                self::NAME,
                null,
                InputOption::VALUE_REQUIRED,
                'Name'
            )
        ];

        $this->setName('refilo:sync:categories');
        $this->setDescription('Import Categories');
        $this->setDefinition($options);

        parent::configure();
    }

    /**
     * Execute the command
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     *
     * @return void
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $this->categories->exportCategories();
        $output->writeln('<info>Success.</info>');
    }

    private function prepareSkuByMask($product)
    {
        /*$productData = $product->getData();
        $skuMask = '';
        if (is_array($section) && array_key_exists('catalog/fields_masks/sku', $section)) {
            $skuMask = $section['catalog/fields_masks/sku']['value'];
        }

        $attributesInPattern = [];
        $count = preg_match_all('/{{(\w+)}}/', $skuMask, $matches);
        if ($count > 0 && is_array($matches[0])) {
            foreach ($matches[1] as $attributeName) {
                if (array_key_exists($attributeName, $productData)) {
                    $attributesInPattern[$attributeName] = $productData[$attributeName];
                }
            }
        }
        foreach ($attributesInPattern as $attributeName => $attributeValue) {
            $skuMask = str_replace('{{' . $attributeName . '}}', $attributeValue, $skuMask);
        }
        return $skuMask;*/
    }
}
